Option Explicit On
Option Strict On

'//////////////////////////////////////////////////////////////
'DShowLib@Tv@Snap
'EJf\ACӂ̃^C~OŐÎ~擾TvłB
'ẼJfŃNbNƁAEɐÎ~悪\܂B
'@iɃNbv{[hɃC[Wۑ܂j
'//////////////////////////////////////////////////////////////

'DirectShowNXCu
Imports DShowLib

Imports System.Runtime.InteropServices

'--------------------------------------------------------------
Public Class Form1

    'W[ϐ
    Private mGrp As IGraphBuilder       'Ot
    Private mSmp As ISampleGrabber      'TvOo

    '----------------------------------------------------------

    'tH[[h
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'ftHg̃Ot
        CreateGraphDefault()

        'Đ
        GraphPlay(mGrp)

    End Sub

    'tH[N[Y
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        'Ot̔j
        DestroyGraph()

    End Sub

    'ftHg̃Ot
    Private Sub CreateGraphDefault()

        '݂̃Otj
        DestroyGraph()

        'Ot
        Dim grp As IGraphBuilder
        grp = CreateNewGraph()

        '߂ɌJOtɒǉ
        Dim flt As IBaseFilter
        flt = AddFilter(grp, DSConst.FilterCategoryGUID.CLSID_VideoInputDeviceCategory, 0) '0Ԗڂ̃J

        'o̓s擾
        Dim pin As IPin
        pin = FindPin(flt, 0, PIN_DIRECTION.PINDIR_OUTPUT)

        'Ot\z
        CreateGraphCore(grp, flt, pin)

    End Sub

    '[UIɂOt
    Private Sub CreateGraphSelect()

        '݂̃Otj
        DestroyGraph()

        '_CAO\
        Dim dlg As New DSUSelectCameraDialog
        Dim grpinfo As New DSUSelectCameraDialog.VIDEOCAPTUREGRAPHINFO
        If dlg.ShowDialog(grpinfo) <> Windows.Forms.DialogResult.OK Then Exit Sub

        'Ot\z
        CreateGraphCore(grpinfo.Graph, grpinfo.Filter, grpinfo.Pin)

        'Đ
        GraphPlay(mGrp)

    End Sub

    'JtB^̏o̓sȍ~\z
    ''' <summary></summary>
    ''' <param name="Grp">Ot</param>
    ''' <param name="Filter">Lv`tB^(JtB^)</param>
    ''' <param name="Pin">Lv`tB^̏o̓s</param>
    ''' <remarks></remarks>
    Private Sub CreateGraphCore(ByVal Grp As IGraphBuilder, ByVal Filter As IBaseFilter, ByVal Pin As IPin)

        'Otۑ
        mGrp = Grp

        'TvOotB^̃CX^X쐬
        Dim smpflt As IBaseFilter
        smpflt = CreateFilter(DSConst.FilterGUID.CLSID_SampleGrabber)

        'ISampleGrabberC^[tF[X擾
        mSmp = CType(smpflt, ISampleGrabber)

        'TvOotB^̓͌`ݒ
        Dim mt As New AM_MEDIA_TYPE
        mt.majorType = New Guid(MediaTypeGUID.MEDIATYPE_Video)      'rfI
        mt.subType = New Guid(MediaTypeGUID.MEDIASUBTYPE_RGB24)     'RGB24
        mSmp.SetMediaType(mt)

        'Otɒǉ
        mGrp.AddFilter(smpflt, "SampleGrabber")

        'tB^ڑ
        mGrp.Render(Pin)

        'TvOoł̃TvOJn
        mSmp.SetBufferSamples(True)

        'TCY擾
        Dim sz As Size
        sz = GetVideoSize(mGrp)

        'EBhETCY
        Pnl_Src.Size = sz
        Pic_Img.Location = New Point(sz.Width, Pnl_Src.Top)
        Pic_Img.Size = sz
        Me.ClientSize = New Size(sz.Width * 2, sz.Height + MenuStrip_Main.Height)

        'plōĐ悤ɂ
        SetVideoRendererOwner(mGrp, Pnl_Src, RendererScale.KeepAspect)

        '_ł̃NbNȂǂplŎ󂯂悤ɂ
        SetVideoRendererEventOwner(mGrp, Pnl_Src)

    End Sub

    'Ot̔j
    Private Sub DestroyGraph()

        If mGrp IsNot Nothing Then

            'Ot~
            GraphStop(mGrp)

            'Otj
            ReleaseInstance(mGrp)

        End If

        mSmp = Nothing

    End Sub

    'j[JINbN
    Private Sub MenuItem_CameraSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem_CameraSelect.Click

        'JIăOt
        CreateGraphSelect()

    End Sub

    'JfNbN
    'EClickCxg͔Ȃ̂ŁAMouseDownCxggp܂B
    Private Sub Pnl_Src_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pnl_Src.MouseDown

        'Xibv
        Snap()

    End Sub

    '----------------------------------------------------------

    'Xibv擾
    Private Sub Snap()

        'ԃ`FbN
        If mSmp Is Nothing Then Exit Sub

        'C[W̎擾
        Try

            '摜f[^TCY擾
            Dim bmpsz As Integer = 0
            mSmp.GetCurrentBuffer(bmpsz, IntPtr.Zero)

            '摜擾̈m
            Dim bmpptr As IntPtr = Marshal.AllocHGlobal(bmpsz)

            'C[W擾
            mSmp.GetCurrentBuffer(bmpsz, bmpptr)

            '`
            Dim bmp As Bitmap
            bmp = New Bitmap(Pic_Img.Width, Pic_Img.Height, Pic_Img.Width * 3, Imaging.PixelFormat.Format24bppRgb, bmpptr)
            bmp.RotateFlip(RotateFlipType.RotateNoneFlipY) '㉺]
            Pic_Img.Image = bmp
            Pic_Img.Refresh()

            'Nbv{[hւ̓\ti܂@\j
            My.Computer.Clipboard.Clear()
            My.Computer.Clipboard.SetImage(bmp)

        Catch ex As Exception

            Debug.Print("摜擾Ɏs܂B")
            Debug.Print("RF" + ex.Message)

        End Try

    End Sub

End Class
